package org.eclipse.cdt.fujitsumcu.errorparser;

import java.util.regex.Matcher;
// import java.util.regex.Pattern;
// import org.eclipse.cdt.core.IMarkerGenerator;
import org.eclipse.cdt.internal.errorparsers.AbstractErrorParser;
import org.eclipse.cdt.internal.errorparsers.ErrorPattern;

public class FujitsuErrorParser extends AbstractErrorParser {
	
/*
	private static final Pattern[] varPatterns = {
		Pattern.compile("'(.*)' undeclared"),
		Pattern.compile("'(.*)' defined but not used"),
		Pattern.compile("conflicting types for '(.*)'"),
		Pattern.compile("parse error before '(.*)'")
	};

*/
	private static final ErrorPattern[] patterns = {
		// The following are skipped
		new ErrorPattern("\\(Each undeclared identifier is reported only once"),
		new ErrorPattern("for each function it appears in.\\)"),
		new ErrorPattern(": note:"),
		new ErrorPattern("instantiated from here"),
		// The following are not...
		
		// *** E4305L: Unresolved external symbol (_clock_init)
		// *** F9011L: Input file not found (./system/src/sys_gpio.o)
		new ErrorPattern("\\*{3} (([IWEF][0-9]{4}.): .*)", 0,0,1,0,2),
		// *** D:\Workspace\TSFW_Fujitsu\system\inc\sys_lcd.h(24) E4038P: #include: cannot find file "75x_lib.h"
		new ErrorPattern("\\*{3} (.+?)\\(([0-9]{1,4})\\) (([IWEF][0-9]{4}.): .*)", 1,2,3,4,0) {
			public int getSeverity(Matcher matcher) {
				String warningGroup = matcher.group(4); // 5
				if (warningGroup.startsWith("I"))
					return 0;  // Info
				else if (warningGroup.startsWith("W"))
					return 1; // Warning
				else if (warningGroup.startsWith("E"))
					return 2; // Error
				else
					return 3; // Fatal
			}			
		}
		
/*		new ErrorPattern("(.*?):([0-9]+):([0-9]+:)? ((warning: )?.*)", 1, 2, 4, 0, 0) {
			public String getVarName(Matcher matcher) {
				String desc = getDesc(matcher);
				Matcher varMatcher = null;
				for (int i = 0; i < varPatterns.length; ++i) {
					varMatcher = varPatterns[i].matcher(desc);
					if (varMatcher.find())
						break;
					else
						varMatcher = null;
				}

				return varMatcher != null ? varMatcher.group(1) : null;
			}

		}
		
		*/
	};


	public FujitsuErrorParser() {
		super(patterns);
	}
	
}